//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBAnimationBrowser extends MSBPropertyButton;

var string AniName;
var name immediatePlayAniName;

var Material AniTex;

var float AniRate;
var bool bLoop;

var MSBPawn P;
var MSBSpritePawn sP;

var bool LeftSide;

var class<MSBPropertyButton> ButtonClass;
var array<string> Properties;
var array<string> MSBPropertyButtons;
var array<MSBPropertyButton> ListButton;

function PostBeginPlay()
{
local MSBNodeButton NB;
local int i;

super.PostBeginPlay();
setTimer(0.2,false);

//crawl up the nodeTree
NB=MSBNodeButton(Mouse.hudTargetActor);

// MSBSpritePawn
for (NB=MSBNodeButton(Mouse.hudTargetActor);NB.Order!=None;NB=NB.NodeIn.ParentNode.myNode)  //crawling up the links...
  {
  if (NB.Order.IsA('MSBSpriteNode'))
    {
    sP=MSBSpriteNode(NB.Order).BasePawn;
    for (i=0;i<sP.Aniname.length;i++)
      {
      MSBPropertyButtons[i]="MSBPropertyButtons.MSBPropertyButtonAssign";
      Properties[i]=sP.Aniname[i].Angle[3];
      if (Properties[i]=="")
        Properties[i]=sP.Aniname[i].Angle[0];
      Log(sP.Aniname[i].Angle[3]);
      }
    }
  if (NB.Order.IsA('MSBRootNode'))
    {
    P=MSBPawn(MSBRootNode(NB.Order).BasePawn);
    for (i=0;i<P.Aniname.length;i++)
      {
      MSBPropertyButtons[i]="MSBPropertyButtons.MSBPropertyButtonAssign";
      Properties[i]=P.Aniname[i];
      }
    }
  if (NB.NodeIn==None)
    break;
  }

MSBPropertyButtons[i]="MSBPropertyButtons.MSBPropertyButtonText";
Properties[i]="AniRate";
}

function Trigger(Actor Other, Pawn EventInstigator)
{
if (sP!=None)
  {
  AniTex=Material(DynamicLoadObject(AniName,class'Material',true));
  Log("Our Animation Texture is:"@AniTex);
  }

if (P!=None)
  {
  SetPropertyText("immediatePlayAniName",Aniname);
  P.PlayAnim(immediatePlayAniName,AniRate);
  }

MSBNodeButton(Parent).Order.SetPropertyText("AniName", AniName);
MSBNodeButton(Parent).Order.SetPropertyText("AniRate", string(AniRate));
MSBNodeButton(Parent).Order.SetPropertyText("bLoop", string(bLoop));
}

function initButton(Canvas C)
{
local vector lOff;
local rotator rOff;

checkBorders(C.ClipX,C.ClipY);
super.InitButton(C);

//draw Portal ontop of Material
C.SetPos(xpos+10,ypos+10);
if (P!=None)
  {
  rOff=rotator(-vector(P.Rotation));
  lOff=vector(P.Rotation);
  lOff=100*normal(lOff);
  if (P!=None)
    C.DrawPortal(xpos+2,ypos+2,width-4,width-4,self,P.Location+lOff,rOff,90,false);
  }
if (sP!=None && AniTex!=None)
  {
  C.DrawTile(aniTex,128,256,0,0,512,1024);
  }

if (ListButton.Length==0)
  spawnAniButtons();

C.SetPos(xpos,ypos);
}

function checkBorders(int xWidth, int yHeight)
{
if (xpos+width+100>xWidth)
   {
    xpos=xpos-width-MSBGuiOverlay(Parent).width;
    LeftSide=true;
   }
if (ypos+height+64>yHeight)
    {
    ypos=ypos-height-64;
    xpos=xpos-MSBGuiOverlay(Parent).width;
    }
}

function SpawnAniButtons()
{
local int i;
Log("Are we Leftside?"@LeftSide);

for (i=0;i<Properties.length;i++)   //spawn a button for each animation and for aniRate!
  {
  ButtonClass = class<MSBPropertyButton>(DynamicLoadObject(MSBPropertyButtons[i], class'Class'));
  ListButton[i]=Spawn(ButtonClass);
  ListButton[i].Parent=self;
  ListButton[i].SubLevel=SubLevel+1;
  if (LeftSide)
    ListButton[i].xPos=xpos-ListButton[i].width;        //horizontal alignment Left
  else
    ListButton[i].xPos=xpos+width;        //horizontal alignment
  ListButton[i].yPos=ypos+(i+1)*ListButton[i].height;
  ListButton[i].BtnName=Properties[i];
  ListButton[i].Property="AniName";
  Log(ListButton[i]);
  }
i--;
// Another Action is the AniRate Action
ListButton[i].Property="AniRate";
ListButton[i].Value=string(AniRate);
ListButton[i].xPos=xPos;
ListButton[i].yPos=yPos+height;
}


function LeftBtn(Canvas C)
{
super.LeftBtn(C);
LeftBtnFinished(C);
}

function MouseOver(Canvas C);

defaultproperties
{
width=256
height=272
xpos=200
ypos=200
}
