class MSBController extends PlayerController
config (MSBCode);

var bool bHasInteraction;
var MSBInterAction MInteract;
var MSBMouseOverlay Mouse;

var config array<string> ContextButtonList;    //for Context Menu
var config array<string> ContextButtonCommand;
var config array<string> ContextButtonName;

var() array<string> SaveGames;
var() array<string> SaveUTCharacters;
var() array<string> SaveCharacters;
var() array<string> SaveCharParts;
var() array<string> Save2DCharacters;
var() array<string> SaveProps;
var() array<string> SaveAnimations;
var() array<string> SavePoses;

var() config float MouseSens;
var() config array<string> VoxelShader;

var int screenX,
        screenY;

//Lists for quickly finding objects
var array<MSBScriptNodeButton> LevelMSBScriptNodes;
var array<MSBNodeButton> LevelNodes;
var array<MSBExtendedListButton> LevelComplexButtons;
var array<MSBActor> LevelActors;
var array<MSBPawn> LevelPawns;
var array<MSBContainerButton> LevelContainers;
var array <Actor> LevelSpecial;

// selecting and showing references
var array <MSBPointActor> pointers;
var array <MSBSelectPointActor> SelectPointers;
var bool canSelect;

var bool bPlay;
var bool bMove;

var bool bStartRender;
var string filename;

var() config bool bGrid;
var() config int Gridspacing;

var float RunTime;

var() vector StartLoc; //moved from VoxelEdController
var rotator StartRot;

var Sound mySound;


event PostBeginPlay()
{
local MSBGeneralPrefs gp;
local int i;

super.PostBeginPlay();
gp=Level.game.LoadDataObject(class'MSBGeneralPrefs',"GeneralConfig","GeneralConfig");
if (gp==None)
  {
  Level.Game.CreateDataObject(class'MSBGeneralPrefs',"GeneralConfig","GeneralConfig");
  Level.Game.SavePackage("GeneralConfig");
  Log("Creating General Config File! Is this the first time you are running the program?");
  }
else
  LoadGeneralConfig(gp);

pointers[i]=Spawn(class'MSBPointActor',,,Location);
pointers[i].bHidden=true;
selectPointers[i]=Spawn(class'MSBSelectPointActor',,,Location);
selectPointers[i].bHidden=true;
}

function PlayerTick(float DeltaTime)
{
super.PlayerTick(DeltaTime);
if (bPlay)
  RunTime+=DeltaTime;

if(Mouse!=None && !Mouse.bTyping)
  {
  Mouse.joyUaxis=aStrafe/100;
  Mouse.joyVaxis=aUp/100;
  Mouse.joyXaxis=(aTurn-aMouseX)/100;
  Mouse.joyYaxis=(-aLookUp+aMouseY)/100;
  }

//  MSBHud(myHud).debugString="aStrafe"@aStrafe@"aUp"@aUp@"aTurn"@aTurn@"aLookup"@aLookup;
}

state MSBCode
{
  function PlayerTick(float DeltaTime)
  {
  global.playerTick(DeltaTime);
  //2D Positioning
  if (Mouse!=None && !Mouse.bTyping)
   {
    Mouse.xPos+=DeltaTime*MouseSens*aMouseX+aStrafe/6000;
    Mouse.yPos-=DeltaTime*MouseSens*aMouseY+aForward/6000;
    }
  }

Begin:
 if (MInteract==None)
 {
   Player.InteractionMaster.AddInteraction("MSBCode.MSBInterAction", Player);
   bHasInteraction=true;
   Mouse=MSBHud(myHud).MouseOverlay;
   MInteract.Mouse=MSBHud(myHud).MouseOverlay;
   Log("PlayerController spawns an Interaction");
   }
}

state MoveObject
{

  function PlayerMove(float DeltaTime)
  {
        local vector X,Y,Z;

        ViewTarget.GetAxes(Rotation,X,Y,Z);
        Acceleration = 0.02 * (aForward*X + aStrafe*Y + aUp*vect(0,0,1));
        UpdateRotation(DeltaTime, 1);
        ViewTarget.MoveSmooth(SpectateSpeed * Normal(Acceleration) * DeltaTime);
        ViewTarget.SetRotation(Rotation);
  }
}

exec function RunMovie()
{
local MSBActor MSA;
local MSBPawn MSP;
local MSBInterpolationHelper I;
local MSBRootNode R;
local MSBScriptNode S;
local MSBScriptTriggerNode T;

bPlay=!bPlay;
Log("executing Start/Stop Script");

if (bPlay)          //start now!
  {
  Tag='running';
  RunTime=0;

 // Mouse.deSelectAll();

  foreach AllActors(class'MSBRootNode',R)
    if (R!=None)
      R.initialize();

  foreach AllActors(class'MSBScriptTriggerNode',T)
    if (T!=None)
      T.initialize();

  foreach AllActors(class'MSBScriptNode',S)
    if (S!=None)
      S.initialize();


  foreach AllActors(class'MSBActor',MSA)
    if (MSA!=None)
      {
      MSA.RunMovie();
      //MSA.Reset();
      if (!MSA.bDisplayed)
        MSA.bHidden=true;
      }

  foreach AllActors(class'MSBPawn',MSP)
    if (MSP!=None)
      {
      MSP.iniPosing();
      MSP.RunMovie();
      }

  MSBHud(myHUD).DrawOverlays=false;

  if (bStartRender)
    ConsoleCommand("recordmovie start filename="$filename@"Quality=1 Width=720 Height=540 fps=25");
  }
else                 // end now!
  {
  if (bStartRender)
    {
    ConsoleCommand("recordmovie stop");
    bStartRender=false;
    }
  Tag='constructing';

  foreach AllActors(class'MSBRootNode',R)
    if (R!=None)
      R.Reset();

  foreach AllActors(class'MSBScriptNode',S)
    if (S!=None)
      S.Reset();

  MSBHud(myHUD).DrawOverlays=true;

  foreach AllActors(class'MSBActor',MSA)
    if (MSA!=None)
      {
      MSA.bHidden=false;
      MSA.StopMovie();
      MSA.Reset();
      }
  foreach AllActors(class'MSBPawn',MSP)
    if (MSP!=None)
        MSP.clearPosing();

  foreach AllActors(class'MSBInterpolationHelper',I)
    {
    Log("Destroying:"@i);
    if (I!=None)
      I.Destroy();
    }

  }
}

exec function switchStates()
{
bMove=!bMove;
if (bMove)
  {
  disableMidLayer();
  GotoState('Spectating');
  }
else
  {
  enableMidLayer();
  GotoState('MSBCode');
  }
}

exec function disableMidLayer()
{
MSBSceneEditorHud(myHud).DrawMidLayer=false;
}

exec function enableMidLayer()
{
MSBSceneEditorHud(myHud).DrawMidLayer=true;
}

function calculateGrid(out vector gridPos)
{
gridPos.X=int(gridPos.X/gridSpacing)*gridSpacing;
gridPos.Y=int(gridPos.Y/gridSpacing)*gridSpacing;
gridPos.Z=int(gridPos.Z/gridSpacing)*gridSpacing;
}

exec function ToggleGrid()
{
bGrid=!bGrid;
}

exec function SetGridSpacing(int spacing)
{
GridSpacing=spacing;
}


exec function LoadGeneralConfig(MSBGeneralPrefs gp)
{
local int i;
for (i=0;i<gp.saveGames.length;i++)
  Savegames[i]=gp.SaveGames[i];

for (i=0;i<gp.saveUTCharacters.length;i++)
  SaveUTCharacters[i]=gp.SaveUTCharacters[i];

for (i=0;i<gp.saveCharacters.length;i++)
  {
  SaveCharacters[i]=gp.SaveCharacters[i];
  }

for (i=0;i<gp.saveCharParts.length;i++)
  SaveCharParts[i]=gp.SaveCharParts[i];

for (i=0;i<gp.save2DCharacters.length;i++)
  Save2DCharacters[i]=gp.Save2DCharacters[i];

for (i=0;i<gp.saveProps.length;i++)
  SaveProps[i]=gp.SaveProps[i];

for (i=0;i<gp.saveAnimations.length;i++)
  SaveAnimations[i]=gp.SaveAnimations[i];

for (i=0;i<gp.savePoses.length;i++)
  SavePoses[i]=gp.SavePoses[i];
Log("General Config loaded");
}

exec function SaveGeneralConfig()
{
local int i;
local MSBGeneralPrefs gp;

gp=Level.Game.LoadDataObject(class'MSBGeneralPrefs',"GeneralConfig","GeneralConfig");
for (i=0;i<saveGames.length;i++)
  gp.SaveGames[i]=Savegames[i];

for (i=0;i<saveUTCharacters.length;i++)
  gp.SaveUTCharacters[i]=SaveUTCharacters[i];

for (i=0;i<saveCharacters.length;i++)
  gp.SaveCharacters[i]=SaveCharacters[i];

for (i=0;i<saveCharParts.length;i++)
  gp.SaveCharParts[i]=SaveCharParts[i];

for (i=0;i<save2DCharacters.length;i++)
  gp.Save2DCharacters[i]=Save2DCharacters[i];

for (i=0;i<saveProps.length;i++)
  gp.SaveProps[i]=SaveProps[i];

for (i=0;i<saveAnimations.length;i++)
  gp.SaveAnimations[i]=SaveAnimations[i];

for (i=0;i<savePoses.length;i++)
  gp.SavePoses[i]=SavePoses[i];
Level.Game.SavePackage("GeneralConfig");
Log("General Config written!");
}

exec function CleanUp()
{
local int i;
local ScriptedSequence S;

//remove Interaction
MInteract.M=None;
MInteract.Mouse=None;
Player.InteractionMaster.RemoveInteraction(MInteract);
Log("removing Interaction"@MInteract);
MInteract=None;
bHasInteraction=false;
MSBHud(myHud).DoFOverlay.Destroy();
//destroy all actions
foreach AllActors(class'ScriptedSequence', S)
  for (i=0;i<S.Actions.length;i++)
    S.Actions[i]=None;

// clear LevelNode array
for (i=0;i<LevelNodes.length;i++)
  LevelNodes[i]=None;
}


// ********************************************************************************
// general Commands and "soon to be implemented" things
// ********************************************************************************

exec function startRender (string fn)
{
bStartRender=true;
filename=fn$".avi";
RunMovie();
}

exec function placeMSBActor(string SpawnActorClassName)
{
local MSBActor SpawnActor;
local vector x,y,z;
local class <MSBActor> SpawnActorClass;

if (SpawnActorClass==None)
  SpawnActorClass = class<MSBActor>(DynamicLoadObject(SpawnActorClassName, class'Class'));
SpawnActor = Spawn(SpawnActorClass,,,Location,Rotation);

LevelActors.Insert(LevelActors.Length,1);
LevelActors[LevelActors.Length-1]=SpawnActor;
GetAxes(Rotation,x,y,z);
SetLocation(SpawnActor.Location-X*100);
}

exec function MousePlaceMSBActor(string SpawnActorClassName)
{
local MSBActor SpawnActor;
local class <MSBActor> SpawnActorClass;

if (SpawnActorClass==None)
  SpawnActorClass = class<MSBActor>(DynamicLoadObject(SpawnActorClassName, class'Class'));
SpawnActor = Spawn(SpawnActorClass,,,Mouse.Mouse3D,Rotation);

LevelActors.Insert(LevelActors.Length,1);
LevelActors[LevelActors.Length-1]=SpawnActor;
}

exec function placeKeyFrame()
{
local MSBActor KeyActor;
local vector x,y,z;
local int i;

for (i=0;i<Mouse.selectedActor.length;i++)
  {
  KeyActor=MSBActor(Mouse.selectedActor[i]);
  KeyActor.Keys[KeyActor.Keys.length]=Spawn(class'MSBKeyFrame',KeyActor,,Location);
  KeyActor.Keys[KeyActor.Keys.length-1].KeyNumber=KeyActor.Keys.length-1;
  LevelActors[LevelActors.Length]=KeyActor.Keys[KeyActor.Keys.length-1];
  }

GetAxes(Rotation,x,y,z);
SetLocation(Location-X*100);
}


exec function importPose(string PoseName, string PosePackagename)
{
local int i;
local MSBAniKey A,B;
local bool bOverwrite;
Log("loading Pose!");

for (i=0;i<63;i++)
  {
  A=Level.Game.LoadDataObject(class'MSBAniKey',PoseName$"Key"$i,PosePackageName);
  if (A!=None)
    {
    B=Level.Game.CreateDataObject(class'MSBAniKey',PoseName$"Key"$i,"MovieSandboxPoses");
    B.BoneRotation=A.BoneRotation;
    B.BoneNumber=A.BoneNumber;
    }
  }

//update SavePose List
for (i=0;i<SavePoses.length;i++)
  if (PoseName==SavePoses[i])
     bOverwrite=true;
if (!bOverwrite)
  SavePoses[SavePoses.Length]=PoseName;
SaveGeneralConfig();
}

exec function SetBrushSize(float size)
{
local MSBSimpleBlock block;

foreach allactors (class'MSBsimpleBlock',block)
  block.SetDrawScale(size);
}

exec function setKneeling(optional MSBPawn P)
{
local int oldRadius, oldHeight, i;

if (P==None)
 {
 for (i=0;i<Mouse.selectedActor.length;i++)
  {
  oldRadius=Mouse.selectedActor[i].CollisionRadius;
  oldHeight=Mouse.selectedActor[i].CollisionHeight;
  Mouse.selectedActor[i].SetCollisionSize(oldRadius/2,oldHeight/2);
  }
 }
else
 {
  oldRadius=P.CollisionRadius;
  oldHeight=P.CollisionHeight;
  P.SetCollisionSize(oldRadius/2,oldHeight/2);
 }
}

//Crouching here!!!

exec function TestMe()
{
local MSBPawn P;

foreach AllActors(class'MSBPawn',P)
 if (P!=None)
  {
//crouching:
//  P.bWantsToCrouch=true;
  //P.CrouchHeight=40;
  //P.CrouchRadius=34;
  //P.IdleCrouchAnim='None';
//  P.SetPhysics(PHYS_Falling);
  P.SetBoneLocation('bip01 Spine',StartLoc);
  }
}

exec function Emit()
{
local Emitter E;
local int i;

foreach AllActors(class'Emitter',E)
  break;

for (i=0;i<E.Emitters[0].Particles.length;i++)
  {
  E.Emitters[0].Particles[i].Location.X=0;
  E.Emitters[0].Particles[i].Location.Y=0;
  E.Emitters[0].Particles[i].Location.Z=0;
  }
}

exec function setStanding()
{
local int oldRadius, oldHeight, i;
for (i=0;i<Mouse.selectedActor.length;i++)
  {
  oldRadius=Mouse.selectedActor[i].CollisionRadius;
  oldHeight=Mouse.selectedActor[i].CollisionHeight;
  Mouse.selectedActor[i].SetCollisionSize(oldRadius*2,oldHeight*2);
  }
}

exec function BlocksToBrushes()
{
local MSBSimpleBlock block;

//foreach allactors (class'MSBsimpleBlock',block)
//  {
//   if (block.Shader==None)
//     {
//     block.Shader=new class'MSBBrushShader';
//     block.shader.Parent=block;
//     }
//  }
}

exec function SetDebug()
{
local MSBActor A;

foreach allactors (class'MSBActor',A)
 if (A!=None)
   A.SetDebug();
}

exec function GrowBlocks()
{
local MSBSimpleBlock block;

//black to blue
foreach allactors (class'MSBsimpleBlock',block)
  {
  if (block!=None)
  block.SetDrawScale(block.DrawScale+0.025);
  }
}

exec function BlackToGrey()
{
local MSBSimpleBlock block;

//black to blue
foreach allactors (class'MSBsimpleBlock',block)
  {
  if (ColorModifier(block.Skins[0]).Color.G==0 && ColorModifier(block.Skins[0]).Color.R==0 && ColorModifier(block.Skins[0]).Color.B==0)
    {
    ColorModifier(block.Skins[0]).Color.R=32;
    ColorModifier(block.Skins[0]).Color.G=32;
    ColorModifier(block.Skins[0]).Color.B=32;
    }
  }
}

exec function Contain()
{
local int i, currentNode;
local MSBContainerButton C;

C= Spawn(class'MSBContainerButton',self);
C.xPos=20;
C.yPos=500;

for (currentNode=0;currentNode<LevelNodes.length;currentNode++)
  if (LevelNodes[currentNode].bSelected)
    C.containedNodes[i++]=currentNode;

for (currentNode=0;currentNode<LevelMSBScriptNodes.length;currentNode++)
  if (LevelMSBScriptNodes[currentNode].bSelected)
    C.containedScriptNodes[i++]=currentNode;

for (currentNode=0;currentNode<LevelContainers.length;currentNode++)
  if (LevelContainers[currentNode].bSelected)
    C.containedContainers[i++]=currentNode;

C.hideContent(true);
Mouse.deSelectAll();
}

exec function saveTest()
{
local Object O;
local Manifest Ma;

//O=Level.Game.CreateDataObject(class'Object',"myName","myTest");

Ma=Level.Game.GetSavedGames();
}

exec function TestDir(string dir,optional bool bCreate, optional string createName)
{
local StreamInterface SI;
local array <string> myContents;
local int i;

SI=new(None) class'StreamInterface';

if (!SI.ValidDirectory(dir))
  Log("This is an invalid directory!");

SI.ChangeDirectory(dir);
Log("We're in:"@SI.GetCurrentDirectory());

SI.GetDirectoryContents(myContents,dir,EFileType(4));

for (i=0;i<myContents.length;i++)
  Log(myContents[i]);

Log("and now for the directories:");
SI.GetDirectoryContents(myContents,SI.GetCurrentDirectory());

for (i=0;i<myContents.length;i++)
  Log("Directories:"@myContents[i]);
}

exec function letstalk()
{
local MSBVoxelPawn P;
local int i;
local MSBMouthBlock B;

foreach AllActors (class'MSBVoxelPawn',P)
  {
  for (i=0;i<P.Blocks.length;i++)
    {
    if (P.Blocks[i].BoneNumber==25)
      {
      Log("found HeadBone!");
      B=Spawn(class'MSBMouthBlock',P.Blocks[i],,P.Blocks[i].Location);
      B.M=P.Blocks[i];
      P.Blocks[i].S[P.Blocks[i].S.length]=B;
      P.MSBFaceBlock[P.MSBFaceBlock.length]=B;
      Log(P.MSBFaceBlock[0]);
      B.SetRotation(P.Blocks[i].Rotation);
      B.SetRelativeLocation(B.Location-P.Blocks[i].Location);
      P.Blocks[i].AttachToBone(B,'');
      }
    }
  }
}

exec function BassDrum()
{
local AmbientSound A;

foreach AllActors(class'AmbientSound',A)
  if (A!=None)
    A.AmbientSound=mySound;
}


exec function StopDrum()
{
local AmbientSound A;

foreach AllActors(class'AmbientSound',A)
  if (A!=None)
    A.AmbientSound=None;
}

defaultproperties
{
DesiredFOV=90
DefaultFOV=90
InitialState=MSBCode
bHasInteraction=true
MouseSens=0.7
bGrid=true
Gridspacing=4
SpectateSpeed=100
canSelect=true


ContextButtonList(0)="MSBPropertyButtons.MSBPropertyButtonCommand"
ContextButtonList(1)="MSBPropertyButtons.MSBPropertyButtonCommand"
ContextButtonList(2)="MSBPropertyButtons.MSBPropertyButtonCommand"

ContextButtonCommand(0)="MousePlaceMSBActor MSBObjects.MSBMoveTargetActor"
ContextButtonCommand(1)="MousePlaceMSBActor MSBObjects.MSBTargetActor"
ContextButtonCommand(2)="SaveThis"

ContextButtonName(0)="Move Target"
ContextButtonName(1)="General Target"
ContextButtonName(2)="Save"

mySound=Sound'BobBlockSounds.RhythmStuff'
}

