//-----------------------------------------------------------
//  A ListButton Spawns a number of SubButtons
//  just like in a Menu.
//  Once another Button is triggered, the Menu is being removed.
//
//  Copyright 2005 Friedrich Kirschner
//-----------------------------------------------------------
class MSBListButton extends MSBGuiOverlay
config(MSBCode);

var config array<String> ButtonList;
var class<MSBGuiOverlay> ButtonClass;
var array<MSBGuiOverlay> ListButton;

//Buttonlist page system:
var int lastpage,maxButtons,maxListSize,currentpage, additionalButtons;

function LeftBtn(Canvas C)                      //spawns subButtons
{
local int i;
super.LeftBtn(C);

if (yPos>C.CLipY-height)
  yPos=C.ClipY-height-256;
if (xPos>C.ClipX-width)
  xPos=C.ClipX-width-64;

if ((currentpage+1)*maxListSize<=Buttonlist.length + additionalButtons)
  maxButtons=(currentpage+1)*maxListSize;
else
  maxButtons=Buttonlist.length + additionalButtons;

// revisit button distribution...
for (i=currentpage*maxListSize;i<maxButtons; i++)
  {
  if (ButtonList[i]!="")
    {
    ButtonClass = class<MSBGuiOverlay>(DynamicLoadObject(ButtonList[i], class'Class'));
    ListButton[i]=Spawn(ButtonClass,self,,M.Location);
    positionButton(C,i);
    ListButton[i].SubLevel=SubLevel+1;
    }
  }

if (Buttonlist.length>maxListSize)
  {
  //create next/prev page buttons
  ListButton[i]=Spawn(class'MSBNextPageButton',self,,M.Location);
  MSBNextPageButton(ListButton[i]).Parent=self;
  ListButton[i].xPos=xpos+width;
  ListButton[i].yPos=ListButton[i-1].ypos+ListButton[i-1].height+1;
  ListButton[i].SubLevel=SubLevel+1;

  ListButton[++i]=Spawn(class'MSBPrevPageButton',self,,M.Location);
  MSBPrevPageButton(ListButton[i]).Parent=self;
  ListButton[i].xPos=xpos+width;
  ListButton[i].yPos=ListButton[i-1].ypos+ListButton[i-1].height+1;
  ListButton[i].SubLevel=SubLevel+1;
  }
}

function positionButton(Canvas C, int i)
{
if (ListButton[i].height<60)
  ListButton[i].xPos=xpos+width;
else
  {
  ListButton[i].xPos=xpos-16 -2*width;
  if (Listbutton[i].xPos<C.ClipX)
    ListButton[i].xPos=xpos+16+2*width;
  }

if (i>currentpage*maxListSize)
  {                          //horizontal alignment
  ListButton[i].yPos=ListButton[i-1].ypos+ListButton[i-1].height+1;
  if (ListButton[i].yPos+ListButton[i].height>C.ClipY && ListButton[i].height<60)
    {
    ListButton[i].ypos=yPos-(i*ListButton[i].height+height+1);
    }
  }
else
  ListButton[i].yPos=ypos;
}

DefaultProperties
{
tooltip="Click for more Options"
xPos=0
yPos=64
maxListSize=10
}
