//-----------------------------------------------------------
//a Wrapper Class for Unreal Classes
//-----------------------------------------------------------
class MSBActorWrapper extends MSBActor;

var Actor Child;
var string WrappedActorClassName;

function Tick(float DeltaTime)
{
super.Tick(DeltaTime);
if (Child!=None && !bHidden)
  {
  Child.SetDrawScale3D(drawScale3D);
  Child.SetLocation(Location);
  Child.SetRotation(Rotation);
  }
}

function RunMovie()
{
super.RunMovie();
bHidden=true;
Child.TriggerEvent('RunMovie',self,None);
}

function StopMovie()
{
Child.TriggerEvent('StopMovie',self,None);
bHidden=false;
Log (initialLocation);
}

function WrapCollision()
{
SetCollisionSize(Child.CollisionRadius+2,Child.CollisionHeight+2);
}

function Trigger(Actor Other, Pawn EventInstigator)
{
super.Trigger(Other, EventInstigator);
Child.Trigger(Other,EventInstigator);
}

event Destroyed()
{
super.Destroyed();
Child.Destroy();
}

function LoadProp()
{
local class<Actor> ActorClass;
super.LoadProp();

ActorClass = class<Actor>(DynamicLoadObject(WrappedActorClassName, class'Class'));
Child=Spawn(ActorClass, self,,Location,Rotation);
}

DefaultProperties
{
ButtonList(5)="MSBPropertyButtons.MSBPropertyButtonAssign"
Properties(5)="Trigger"
ButtonList(6)="None"
Properties(6)="WrappedActorClassName"
bDisplayed=true
}
