//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBLipSyncHead extends MSBActor;

//***************************************************************************
// SkinSwapping
var string Head, Eyes, Eyebrows, Mask, MouthOpen, MaskMouthOpen;

var Material MatHead;
var Material MatMask;
var Material MatEyes;
var Material MatEyeBrows;
var Material MatMouthOpen;
var Material MatMaskMouthOpen;
var TexScaler moveEyes;
var TexScaler moveBrows;
var Combiner EyesAndHead;
var Combiner HeadAndBrows;
var Shader finishedHead;

//***************************************************************************
// Bone Variables
var int MouthBoneEnd;
var name MouthBone[19];

var vector openHigh[19];
var vector openMed[19];
var vector openLow[19];

var float Time;
var() float minMouthTime;
var int currentMouthPose;

//***************************************************************************
// Actor Variables
var vector msaBase;                 //base location of actor - needs change if actor moves...
var float amp,Amplitude;            //amp=current relative z-pos, amplitude=max relative zpos

//***************************************************************************
// general Variables
var() float eyeX, eyeY;
var() float browX, browY;

var MSBLipSyncUdpLink LipSyncUDP;
var int channel;

var MSBActor MSA;
var MSBPawn MSP;

var PlayerController PC;

//***************************************************************************
// ini-Stuff
function PostBeginPlay()
{
Super.PostBeginPlay();
PC=Level.GetLocalPlayerController();
iniHead();
}

event iniHead()
{
Log("init MSBLipSyncHead");
if (LipSyncUDP==None)
  LipSyncUDP=Spawn(class'MSBLipSyncUdpLink',self);
LipSyncUDP.InitUdpLink(LipSyncUdp.iPort+channel);

if (Head!="")
  {
  MatHead=Material(DynamicLoadObject(Head,class'Material',true));
  MatMask=Material(DynamicLoadObject(Mask,class'Material',true));
  MatMouthOpen=Material(DynamicLoadObject(MouthOpen,class'Material',true));
  MatMaskMouthOpen=Material(DynamicLoadObject(MaskMouthOpen,class'Material',true));
  MatEyes=Material(DynamicLoadObject(Eyes,class'Material',true));
  MatEyeBrows=Material(DynamicLoadObject(Eyebrows,class'Material',true));

  if (moveEyes==None)
    moveEyes=new class'TexScaler';
  moveEyes.Material=MatEyes;

 if (moveBrows==None)
   moveBrows=new class'TexScaler';
  moveBrows.Material=MatEyeBrows;

  if (EyesAndHead==None)
    EyesAndHead=new class'Combiner';
  EyesAndHead.Material1=moveEyes;
  EyesAndHead.Material2=MatHead;
  EyesAndHead.Mask=MatHead;
  EyesAndHead.CombineOperation=CO_AlphaBlend_With_Mask;

  if (HeadAndBrows==None)
    HeadAndBrows=new class'Combiner';
  HeadAndBrows.Material1=moveBrows;
  HeadAndBrows.Material2=EyesAndHead;
  HeadAndBrows.Mask=moveBrows;
  HeadAndBrows.InvertMask=true;
  HeadAndBrows.CombineOperation=CO_AlphaBlend_With_Mask;

  if (finishedHead==None)
    finishedHead=new class'Shader';
  finishedHead.Diffuse=HeadAndBrows;
  finishedHead.Opacity=MatMask;

  Skins[0]=finishedHead;
  RepSkin=finishedHead;
  }
else
  {
  MatHead=None;
  Skins[0]=Skins[1];
  RepSkin=None;
  }
}

//***************************************************************************
// Face Control (brows and eyes)
function Tick(float DeltaTime)
{

super.Tick(DeltaTime);

if(MSP!=None && MSP.IsA('MSBFullRig'))
  MouthMovement();
else
  SkinSwapping();

//always Look at Camera
SetRotation(rotator(Location-PC.ViewTarget.Location));
Time+=DeltaTime;
}

function SkinSwapping()
{
if (Skins[0]==None && MatHead!=None)
   iniHead();

if (moveEyes!=None)
  {
  moveEyes.UOffset=eyeX;
  moveEyes.VOffset=eyeY;
  }

if (moveBrows!=None)
  {
  moveBrows.UOffset=browX;
  moveBrows.VOffset=browY;
  }
if (MSP!=None && Skins[1]!=None)
  MSP.Skins[1]=Skins[1];
}

function MouthMovement()
{
local vector eyevect, browvect;

// set eyes
eyevect.X=eyeX;
eyevect.Y=eyeY;

MSP.SetBoneLocation(MouthBone[17],eyeVect);
MSP.SetBoneLocation(MouthBone[18],eyevect);

// set brow stuff

browvect.X=browX;
browvect.Y=browY;

MSP.SetBoneLocation(MouthBone[12],browVect);
MSP.SetBoneLocation(MouthBone[14],browvect);

// set smile
// set sad
}


//***************************************************************************
// Lipsyncing
function Trigger(Actor Other, Pawn EventInstigator)
{
if (Other==LipSyncUDP && EyesAndHead.Material2!=MatMouthOpen)
  {
  EyesAndHead.Material2=MatMouthOpen;
  EyesAndHead.Mask=MatMouthOpen;
  finishedHead.Opacity=MatMaskMouthOpen;
  SetTimer(0.3,false);
  }
if (Other==LipSyncUDP && MSP!=None && MSP.IsA('MSBFullRig') && Time>minMouthTime)
  {
  currentMouthPose++;
  if (currentMouthPose>2) currentMouthPose=0;
  OpenMouth(currentMouthPose);
  SetTimer(0.3,false);
  Time=0;
  }

//experimental - see if we can move any object down when we get some udp input...
if (Other==LipSyncUDP && MSA!=None)
  {
  amp+=0.5;
  if (amp>Amplitude) amp=0;
  MSA.SetLocation(msaBAse-vect(0,0,1)*amp);
  //MSA.SetRelativeLocation(msaBase+vect(0,0,1)*amp);
  SetTimer(0.2,false);
  }

if (channel>0 && Other!=LipSyncUDP)
  {
  LipSyncUDP.Destroy();
  LipSyncUDP=Spawn(class'MSBLipSyncUdpLink',self);
  LipSyncUDP.InitUdpLink(LipSyncUdp.iPort+channel);
  }

if (MSA!=None && Other!=LipSyncUDP)
  msaBase=MSA.Location;

}

function Timer()
{
EyesAndHead.Material2=MatHead;
EyesAndHead.Mask=MatHead;
finishedHead.Opacity=MatMask;
Texture(MatMouthOpen).AnimCurrent=texture(MatMouthOpen);
texture(MatMouthOpen).PrimeCount=0;
texture(MatMouthOpen).PrimeCurrent=0;

if(MSP!=None && MSP.IsA('MSBFullRig'))
  CloseMouth();
if(MSA!=None)
  MSA.SetLocation(msaBase);
}


function OpenMouth(int pos)
{
local int i;
local vector MouthOpenPos;

for (i=0;i<MouthBoneEnd;i++)
  {
  if (pos==0) MouthOpenpos=openHigh[i];
  if (pos==1) MouthOpenpos=openMed[i];
  if (pos==2) MouthOpenpos=openLow[i];
  MSP.SetBoneLocation(MouthBone[i],MouthOpenPos);
  }
}

function closeMouth()
{
local int i;
local vector MouthClosedPos;

for (i=0;i<MouthBoneEnd;i++)
  MSP.SetBoneLocation(MouthBone[i],MouthClosedPos);
}



DefaultProperties
{
Amplitude=5
MouthBoneEnd=11
channel=0
Skins(1)=Material'MovieSandboxTextures.Transparent'
Skins(0)=None
AmbientGlow=128
StaticMesh=StaticMesh'MovieSandboxMeshes.helperMeshes.PlaneBox'
DrawType=DT_StaticMesh

Head="MovieSandboxTextures.HeadTex.GarryHead_MouthClosed"
Mask="MovieSandboxTextures.HeadTex.GarryHead_Alpha"
MouthOpen="MovieSandboxTextures.HeadTex.GarryHeadOpen_a00"
MaskMouthOpen="MovieSandboxTextures.HeadTex.GarryHead_Alpha"
Eyes="MovieSandboxTextures.HeadTex.GarryHead_Eyes"
EyeBrows="MovieSandboxTextures.HeadTex.GarryHead_BrowsDown"

//ButtonList(5)="MSBPropertyButtons.MSBPropertyButtonText"
//Properties(5)="Head"
//ButtonList(6)="MSBPropertyButtons.MSBPropertyButtonText"
//Properties(6)="Eyes"
//ButtonList(7)="MSBPropertyButtons.MSBPropertyButtonText"
//Properties(7)="Eyebrows"
//ButtonList(8)="MSBPropertyButtons.MSBPropertyButtonText"
//Properties(8)="Mask"
//ButtonList(9)="MSBPropertyButtons.MSBPropertyButtonText"
//Properties(9)="MouthOpen"
//ButtonList(10)="MSBPropertyButtons.MSBPropertyButtonText"
//Properties(10)="MaskMouthOpen"
ButtonList(5)="MSBPropertyButtons.MSBPropertyButtonText"
Properties(5)="Channel"
//ButtonList(12)="MSBPropertyButtons.MSBPropertyButton3D"
//Properties(12)="MSP"
ButtonList(6)="MSBPropertyButtons.MSBPropertyButton3D"
Properties(6)="MSA"
ButtonList(7)="MSBPropertyButtons.MSBPropertyButtonText"
Properties(7)="Amplitude"


MouthBone(0)=f_lips_top
MouthBone(1)=f_lips_top_r
MouthBone(2)=f_lips_top_l
MouthBone(3)=f_lips_left
MouthBone(4)=f_lips_right
MouthBone(5)=f_lips_btm_r
MouthBone(6)=f_lips_btm_l
MouthBone(7)=f_lips_btm

MouthBone(8)=f_jaw
MouthBone(9)=f_cheek_l
MouthBone(10)=f_cheek_r

MouthBone(11)=f_r_brow_out
MouthBone(12)=f_r_brow_in
MouthBone(13)=f_l_brow_out
MouthBone(14)=f_l_brow_in

MouthBone(15)=f_l_eye
MouthBone(16)=f_r_eye
MouthBone(17)=f_eyelid_l
MouthBone(18)=f_eyelid_r



openHigh(0)=(X=0.000000,Y=-1.300000,Z=0.000000)
openHigh(1)=(X=0.000000,Y=-0.900000,Z=0.000000)
openHigh(2)=(X=0.000000,Y=-0.900000,Z=0.000000)
openHigh(3)=(X=0.300000,Y=-0.400000,Z=0.000000)
openHigh(4)=(X=-0.300000,Y=0.000000,Z=0.000000)
openHigh(5)=(X=0.000000,Y=0.600000,Z=0.000000)
openHigh(6)=(X=0.000000,Y=0.600000,Z=0.000000)
openHigh(7)=(X=0.000000,Y=0.600000,Z=0.000000)

openMed(0)=(X=0.000000,Y=-0.200000,Z=0.000000)
openMed(1)=(X=0.000000,Y=-0.200000,Z=0.000000)
openMed(2)=(X=0.000000,Y=-0.200000,Z=0.000000)
openMed(3)=(X=-0.200000,Y=0.000000,Z=0.000000)
openMed(4)=(X=0.200000,Y=0.000000,Z=0.000000)
openMed(5)=(X=0.000000,Y=-0.100000,Z=0.000000)
openMed(6)=(X=0.000000,Y=-0.100000,Z=0.000000)
openMed(7)=(X=0.000000,Y=-0.500000,Z=0.000000)

openLow(0)=(X=-0.400000,Y=-1.300000,Z=0.000000)
openLow(1)=(X=-0.300000,Y=-1.100000,Z=0.000000)
openLow(2)=(X=0.400000,Y=-1.100000,Z=0.000000)
openLow(3)=(X=1.000000,Y=-0.100000,Z=0.000000)
openLow(4)=(X=-0.800000,Y=0.000000,Z=0.000000)
openLow(5)=(X=0.000000,Y=0.000000,Z=0.000000)
openLow(6)=(X=0.000000,Y=0.000000,Z=0.000000)
openLow(7)=(X=0.000000,Y=0.000000,Z=0.000000)
}
