//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBProp extends MSBActor;

struct PropPart
{
var MSBMasterBlock Bone;
var array<MSBsimpleBlock> Blocks;
};

var array<PropPart> Parts;
var string PropName;

function LoadProp()
{
local MSBBlockCloud cloud;
Log(content);
cloud=Level.Game.LoadDataObject(class'MSBBlockCloud',content,"CharacterParts");
if (cloud.BoneRelLocation.length>0)
  LoadComplexProp(cloud);
else
  LoadSimpleProp(cloud);
}

function LoadComplexProp(MSBBlockCloud cloud)
{
local int pnum, bnum,i;

for (pnum=0;pnum<cloud.BoneRelLocation.length;pnum++)
  {
  Parts.Insert(Parts.Length,1);
  Parts[pnum].Bone= Spawn(class'MSBMasterBlock',self,,Location);
  Parts[pnum].Bone.SetRelativeRotation(cloud.BoneRelRotation[pnum]);
  for(bnum=0;bnum<cloud.BlockRelLocation.length;bnum++)
    {
    if (cloud.BoneNumber[bnum]==pnum)
      {
      Parts[pnum].Blocks[i]=spawn(class'MSBsimpleBlock');
      Parts[pnum].Blocks[i].M=Parts[pnum].Bone;

      Parts[pnum].Blocks[i].Skins[0]=new() class'ColorModifier';
      ColorModifier(Parts[pnum].Blocks[i].Skins[0]).Color=cloud.Col[bnum];
      ColorModifier(Parts[pnum].Blocks[i].Skins[0]).Material=Skins[0];

      Parts[pnum].Bone.AttachToBone(Parts[pnum].Blocks[i],'');
      Parts[pnum].Blocks[i].SetRelativeLocation(cloud.BlockRelLocation[bnum]);
      i++;
      }
    }
  Parts[pnum].Bone.SetDrawType(DT_None);
  Parts[pnum].Bone.SetCollision(false,false,false);
  }
Log("Loading coomplex!");
}

function LoadSimpleProp(MSBBlockCloud cloud)
{
local int i;
local vector newScale;

Log("loading a simple Prop");
Parts.Insert(0,1);
Parts[0].Bone=Spawn(class'MSBMasterBlock',self,,Location,Rotation);
Parts[0].Bone.BoneNumber=-1;
for(i=0;i<cloud.BlockRelLocation.length;i++)
  {
  Parts[0].Blocks[i]=spawn(class'MSBsimpleBlock');
  Parts[0].Blocks[i].bNoRotate=true;
  Parts[0].Blocks[i].M=Parts[0].Bone;
  Parts[0].Blocks[i].Skins[0]=new() class'ColorModifier';
  ColorModifier(Parts[0].Blocks[i].Skins[0]).Color=cloud.Col[i];
  ColorModifier(Parts[0].Blocks[i].Skins[0]).Material=Skins[0];

  Parts[0].Bone.AttachToBone(Parts[0].Blocks[i],'');
  Parts[0].Blocks[i].SetRelativeLocation(cloud.BlockRelLocation[i]>>Rotation);
  Parts[0].Blocks[i].SetDrawScale(cloud.drawScale[i]);
  newScale.X=cloud.drawScale3D[i].Y;
  newScale.Y=cloud.drawScale3D[i].X;
  newScale.Z=cloud.drawScale3D[i].Z;

  Parts[0].Blocks[i].SetDrawScale3D(newScale);
  }
Parts[0].Bone.SetDrawType(DT_None);
Parts[0].Bone.SetCollision(false,false,false);

Log("Loading simple!");
}

function clearActor()
{
local int i;
Log("cleaning out"@name);
Parts[0].Bone.clearBlocks();
//total bescheuert aber is nochmal referenziert
for (i=0;i<Parts[0].blocks.length;i++)
  Parts[0].Blocks[i].Destroy();
Parts[0].Bone.Destroy();
}

DefaultProperties
{
DrawType=DT_None
}
