//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBRagDollPuppet extends MSBActor;

const points=4;
var MSBRagdoll Puppet;
var MSBKActor PuppetControl[points];
var MSBKBSJoint Glue[points];

var Actor MSBInputControl;

var vector leftHandLoc,rightHandLoc,neckLoc;

var bool bRunning;

var int UdpPadCh;

event PostBeginPlay()
{
local MSBTargetActor helper;
local vector myLoc;
local int i;

super.PostBeginPlay();

//create the Puppet
Puppet=Spawn(class'MSBRagdoll',self,,Location,Rotation);

//create the PuppetControls
for (i=0;i<points;i++)
  {
  PuppetControl[i]=Spawn(class'MSBKActor',self,,Location,Rotation);
  Glue[i]=Spawn(class'MSBKBSJoint',self,,Location,Rotation);
  Glue[i].KConstraintActor1=Puppet;
  Glue[i].KConstraintActor2=PuppetControl[i];
  }

Puppet.AttachToBone(Glue[0],'Bip01 L Hand');
Puppet.AttachToBone(PuppetControl[0],'Bip01 L Hand');

Puppet.AttachToBone(Glue[1],'Bip01 R Hand');
Puppet.AttachToBone(PuppetControl[1],'Bip01 R Hand');

Puppet.AttachToBone(Glue[2],'Bip01 Neck');
Puppet.AttachToBone(PuppetControl[2],'Bip01 Neck');

Puppet.AttachToBone(Glue[3],'Bip01 Spine');
Puppet.AttachToBone(PuppetControl[3],'Bip01 Spine');
self.AttachToBone(Puppet,'');
}

function Tick(float DeltaTime)
{
local int i;

//0=leftHand
//1=rightHand
//2=Neck

if (bRunning)
  {
  PuppetControl[0].loc=leftHandLoc;
  PuppetControl[1].loc=rightHandLoc;
  PuppetControl[2].loc=neckLoc;
  }
}

event Trigger(Actor Other, Pawn EventInstigator)
{
if (Other.IsA('MSBGuiOverlay'))
  {
  MSBInputControl.Trigger(Other,None);
  }
}


function RunMovie()
{
local int i;

Puppet.SetPhysics(PHYS_KarmaRagDoll);

for (i=0;i<4;i++)
  {
  PuppetControl[i].SetPhysics(PHYS_Karma);
  Glue[i].SetPhysics(PHYS_Karma);
  PuppetControl[i].TriggerEvent('RunMovie',self,None);
  }

bRunning=true;
}

function Reset()
{
local int i;

for (i=0;i<points;i++)
  {
  Glue[i].SetPhysics(PHYS_None);
  PuppetControl[i].SetPhysics(PHYS_None);
  }

bRunning=false;
Puppet.SetPhysics(PHYS_None);
self.AttachToBone(Puppet,'');
}


DefaultProperties
{
ButtonList(3)="MSBPropertyButtons.MSBPropertyButtonText"
Properties(3)="UdpPadCh"
CollisionRadius=64.0
CollisionHeight=96.0
}
