//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBPropertyButtonTrace extends MSBPropertyButtonText;

var MSBVoxelEdController CC;
var MSBUdpLink myUDP;
var vector gridLoc,x,y,z;
var int stepsX,stepsY, stepsZ;

var int resolution,heightFactor;
var byte red,green,blue, alpha, zValue;


function LeftBtn(Canvas C)
{
super.LeftBtn(C);
CC=MSBVoxelEdController(M);
CC.SetLocation(Parent.Location+M.StartLoc*0.5);
myUDP= spawn(class'MSBUdpLink',self);
myUDP.InitUdpLink(41840);
initTrace();
}

function Trigger(Actor Other, Pawn EventInstigator)
{

if(Other==myUDP)
  {
  alpha= myUDP.byteData[0];
  red=myUDP.byteData[1];
  green=myUDP.byteData[2];
  blue=myUDP.byteData[3];
  zValue=myUDP.byteData[4];
  resolution=myUDP.byteData[5];

  DoTrace();
  }
}

function DoTrace()
{
local float factor;
local vector newScale;

CC.DrawBrush.SetDrawScale(2/resolution);
//going down
if (stepsX%resolution==0)
  {
  stepsY++;
  stepsX=0;
  }

if (alpha>0)
  {
  newScale.X=1;
  newScale.Z=1;
  newScale.Y=zValue/heightFactor;
  MSBHud(M.myHUD).debugString=string(newScale);
  CC.DrawBrush.SetDrawScale3D(newScale);
  stepsZ=newScale.Y/2;
  CC.DrawBrush.red=red;
  CC.DrawBrush.green=green;
  CC.DrawBrush.blue=blue;
  CC.DrawBrush.SetColor();
  CC.DrawBrush.Trigger(CC.myHUD,none);
  }

  factor=16/resolution;
//set the block 1 further
CC.drawBrush.SetLocation(gridLoc+factor*stepsX*Z+factor*stepsY*X-factor*stepsZ*Y);
stepsX++;
}

function initTrace()
{
if (Parent.IsA('MSBMasterBlock'))
  {
  Parent.SetDrawScale3D(vect(1,1,1));
  CC.drawBrush.Master=MSBMasterBlock(Parent);
  gridLoc=Parent.Location;
  CC.calculateGrid(gridLoc);
  CC.drawBrush.SetLocation(gridLoc);
  CC.drawBrush.SetRotation(Parent.Rotation);
  }
//create the tracing thing
cc.drawbrush.GetAxes(cc.drawbrush.Master.rotation,x,y,z);
x=vect(0,1,0);
y=vect(-1,0,0);
z=vect(0,0,1);

//gridloc serves as starting point here!

//arms
if (CC.DrawBrush.Master.BoneNumber>5 && CC.DrawBrush.Master.BoneNumber<17)
  gridLoc=gridLoc-8*z;

//spine
if (CC.DrawBrush.Master.BoneNumber<6)
  {
  gridLoc=gridLoc-8*z;
  gridLoc=gridLoc-8*x;
  }

//head
if (CC.DrawBrush.Master.BoneNumber==25 )
  gridLoc=gridLoc-8*x;

}


DefaultProperties
{
heightFactor=12
tooltip1="Set Master Block"
tooltip2="Select Master Block"
BtnName="Trace"
}
