class MSBVoxelEdController extends MSBController
config;

//voxel related
var MSBBlockBrush DrawBrush;
var color Col;
var int r,g,b;
var MSBVoxelEdPawn myReferencePawn;

//Facequad/Mouth related
var vector MouthRelLocation;
var color MouthColor;
var float MouthScale;
var string MouthMesh;
var int MouthMaster;
var bool bMouthSpawned;
var MSBsimpleBlock FQ;

//internal
var vector xAxis,yAxis,zAxis;
var int oldX,oldY;

var vector nullVect;
var rotator nullrot;
var bool bCharEd;

event PostBeginPlay()
{
local float flGridSpc;

super.PostBeginPlay();
DrawBrush=Spawn(class'MSBBlockBrush',self,,nullVect);
flGridSpc=GridSpacing;
drawBrush.SetDrawScale(flGridSpc/8);
switchMode();
SetLocation(StartLoc);
SetRotation(StartRot);
ContextButtonList.remove(0,ContextButtonList.Length);
refreshMasters();
}

state CharacterEditor
{
  function PlayerTick(float DeltaTime)
  {
  global.playerTick(DeltaTime);
  //2D Positioning
  if (Mouse!=None && !Mouse.bTyping)
   {
    Mouse.xPos+=DeltaTime*MouseSens*aMouseX+aStrafe/6000;
    Mouse.yPos-=DeltaTime*MouseSens*aMouseY+aForward/6000;
    }
  }

Begin:
 if (MInteract==None)
   {
   Player.InteractionMaster.AddInteraction("MSBCode.MSBInteraction", Player);
   bHasInteraction=true;
   Mouse=MSBHud(myHud).MouseOverlay;
   MInteract.Mouse=MSBHud(myHud).MouseOverlay;
   Log("PlayerController spawns an Interaction");
   }
}

exec function RunMovie()
{
bPlay=!bPlay;
Log("switching Draw/select Mode");

refreshMasters();

if (bPlay)          //start now!
  {
  Mouse.bHitActors=false;
  oldX=Mouse.xPos;
  oldY=Mouse.yPos;
  GetAxes(Rotation,xAxis,yAxis,zAxis);
  xAxis.Z=0;
  yAxis.Z=0;
  MSBHud(myHud).DrawOverlays=false;
  }
else
  {
  Mouse.bHitActors=true;
  MSBHud(myHud).DrawOverlays=true;
  }
}

exec function switchStates()
{
bMove=!bMove;
if (bMove)
  GotoState('BaseSpectating');
else
  GotoState('CharacterEditor');
}

exec function switchMode()
{
if (bCharEd)
  {
  if (myReferencePawn==None)
    {
    DrawBrush.Master.clearBlocks();
    DrawBrush.Master.Destroy();
    myReferencePawn=Spawn(class'MSBVoxelEdPawn',,,nullvect);
    myReferencePawn.SetPhysics(PHYS_None);
    myReferencePawn.SetRotation(Rotation*0);
    }
  DrawBrush.Master=myReferencePawn.Blocks[0];
  DrawBrush.SetRotation(0*Rotation);
  }
else
  {
  if (myReferencePawn!=None)
    {
    myReferencePawn.clearBlocks();
    myReferencePawn.Destroy();
    }
  DrawBrush.Master=Spawn(class'MSBMasterBlock',,,nullvect);
  }
bCharEd=!bCharEd;
}

exec function refreshMasters()
{
local int i;

for (i=0;i<myReferencePawn.Blocks.length;i++)
  if (myReferencePawn.Blocks[i]!=DrawBrush.Master)
    myReferencePawn.Blocks[i].SetDrawScale3D(myReferencePawn.Blocks[i].edScale);
}

exec function ToggleMasters()
{
local MSBMasterBlock M;
foreach AllActors (class'MSBMasterBlock',M)
  M.bDisplayed=!M.bDisplayed;
}

exec function SetGridSpacing(int spacing)
{
local float flGridSpc;

super.SetGridSpacing(spacing);
flGridSpc=GridSpacing;
}

exec function calculateGridRelative(vector gridVec)
{
gridVec=gridVec*(GridSpacing*VSize(normal(gridVec)));
}


exec function SpawnMouth()
{
local int i;
local ColorModifier cm;

FQ=Spawn(class'MSBMouthBlock',self,,DrawBrush.Location);
FQ.bEdit=true;
for (i=0;i<FQ.skins.length;i++)
  {
  cm=new() class'ColorModifier';
  cm.Material=ColorModifier(FQ.Skins[i]).Material;
  FQ.Skins[i]=cm;
  ColorModifier(FQ.Skins[0]).Color=ColorModifier(drawBrush.Skins[0]).Color;
  }
FQ.SetRotation(DrawBrush.Master.Rotation);
FQ.SetRelativeLocation(FQ.Location-DrawBrush.Master.Location);
DrawBrush.Master.AttachToBone(FQ,'');
FQ.M=DrawBrush.Master;

MouthRelLocation=FQ.RelativeLocation << DrawBrush.Master.Rotation;
MouthColor=ColorModifier(drawBrush.Skins[0]).Color;
MouthScale=FQ.DrawScale;
MouthMesh=String(FQ.StaticMesh);
for (i=0;i<myReferencePawn.Blocks.length;i++)
  if (DrawBrush.Master==myReferencePawn.Blocks[i])
    MouthMaster=i;
bMouthSpawned=true;
}

exec function SpawnFace(string className)
{
local class<MSBVoxelFace> MSBVoxelFaceClass;
local int i;

MSBVoxelFaceClass=class<MSBVoxelFace>(DynamicLoadObject(className, class'Class'));
FQ=Spawn(MSBVoxelFaceClass,self,,DrawBrush.Location);
FQ.bEdit=true;
FQ.SetRotation(DrawBrush.Master.Rotation);
FQ.SetRelativeLocation(FQ.Location-DrawBrush.Master.Location);
DrawBrush.Master.AttachToBone(FQ,'');
FQ.M=DrawBrush.Master;

MouthRelLocation=FQ.RelativeLocation << DrawBrush.Master.Rotation;
MouthColor=ColorModifier(drawBrush.Skins[0]).Color;
MouthScale=FQ.DrawScale;
MouthMesh=String(FQ.StaticMesh);
for (i=0;i<myReferencePawn.Blocks.length;i++)
  if (DrawBrush.Master==myReferencePawn.Blocks[i])
    MouthMaster=i;
bMouthSpawned=true;
}

exec function DeleteFaceMesh()
{
FQ.Destroy();
bMouthSpawned=false;
}


exec function growBrush()
{
if (drawBrush.DrawScale<3)
  drawBrush.SetDrawScale(drawBrush.DrawScale+0.25);
}

exec function shrinkBrush()
{
if (drawBrush.DrawScale>0.3)
  drawBrush.SetDrawScale(drawBrush.DrawScale-0.25);
}

exec function ChangeMasterColor()
{
local int i;
for (i=0;i<DrawBrush.Master.S.length;i++)
  ColorModifier(DrawBrush.Master.S[i].Skins[0]).Color=ColorModifier(DrawBrush.Skins[0]).Color;
}

exec function clearBlock()
{
MSBMasterBlock(MSBPropertyButton(Mouse.hudTargetActor).Parent).clearBlocks();
}

exec function placeMSBActor(string SpawnActorClassName);


exec function moveToLimb(MSBMasterBlock MB)
{
}

defaultproperties
{
bCharEd=true
StartLoc=(X=81,Y=-32,Z=-6)
StartRot=(Pitch=-524,Yaw=27500)
canSelect=false
}
